###################################################
### chunk number 1: 
###################################################
options(prompt="R> ")
require( "LogConcDEAD" )
require( "logcondens" )
require( "mvtnorm" )
options(width=72)


###################################################
### chunk number 2:  eval=FALSE
###################################################
## install.packages("logcondens")
## library("logcondens")


###################################################
### chunk number 3: setn
###################################################
n <- 200


###################################################
### chunk number 4: 
###################################################
set.seed(1)
n <- 200
x <- sort(rgamma(n,shape=2))
out1 <- activeSetLogCon(x) ## logcondens estimate
out2 <- mlelcd(x) ## LogConcDEAD estimate


###################################################
### chunk number 5: plot:1d eval=FALSE
###################################################
## ylim <- c(0,0.4) 
## lgdtxt <- c("LogConcDEAD", "logcondens", "true")
## lgdlty <- c(1,2,3)
## plot(out2, ylim=ylim,lty=1)
## lines(x, exp(out1$phi), lty=2)
## lines(x, x*exp(-x), lty=3)
## legend(x=3, y=0.4, lgdtxt, lty=lgdlty)


###################################################
### chunk number 6: plot:log1d eval=FALSE
###################################################
## ylim <- c(-4,-1)
## lgdtxt <- c("LogConcDEAD", "logcondens", "true")
## lgdlty <- c(1,2,3)
## plot(out2, uselog=TRUE, lty=1)
## lines(x, out1$phi, lty=2)
## lines(x, log(x)-x, lty=3)
## legend(x=3, y=-1, lgdtxt, lty=lgdlty) 


###################################################
### chunk number 7: fig:1d
###################################################
ylim <- c(0,0.4) 
lgdtxt <- c("LogConcDEAD", "logcondens", "true")
lgdlty <- c(1,2,3)
plot(out2, ylim=ylim,lty=1)
lines(x, exp(out1$phi), lty=2)
lines(x, x*exp(-x), lty=3)
legend(x=3, y=0.4, lgdtxt, lty=lgdlty)


###################################################
### chunk number 8: fig:log1d
###################################################
ylim <- c(-4,-1)
lgdtxt <- c("LogConcDEAD", "logcondens", "true")
lgdlty <- c(1,2,3)
plot(out2, uselog=TRUE, lty=1)
lines(x, out1$phi, lty=2)
lines(x, log(x)-x, lty=3)
legend(x=3, y=-1, lgdtxt, lty=lgdlty) 


###################################################
### chunk number 9: setn2
###################################################
n <- 500


###################################################
### chunk number 10: 
###################################################
set.seed(22)
d <- 2
n <- 500
x <- matrix(rnorm(n*d),ncol=d)


###################################################
### chunk number 11: 
###################################################
out <- mlelcd(x,verbose=200)


###################################################
### chunk number 12: 
###################################################
names(out)


###################################################
### chunk number 13: 
###################################################
out$logMLE[1:5]


###################################################
### chunk number 14: 
###################################################
out$triang[1:5,]


###################################################
### chunk number 15: 
###################################################
out$b[1:5,]
out$beta[1:5]


###################################################
### chunk number 16: 
###################################################
out$NumberOfEvaluations
out$MinSigma


###################################################
### chunk number 17: 
###################################################
out$chull[1:5,]


###################################################
### chunk number 18: 
###################################################
out$outnorm[1:5,]
out$outoffset[1:5,]


###################################################
### chunk number 19: 
###################################################
g <- interplcd(out, gridlen=200)
g1 <- interpmarglcd(out, marg=1)
g2 <- interpmarglcd(out, marg=2)


###################################################
### chunk number 20: plot:2d eval=FALSE
###################################################
## par(mfrow=c(1,2), pty="s", cex=0.7) #square plots
## plot(out,g=g,addp=FALSE,asp=1)
## plot(out,g=g,uselog=TRUE,addp=FALSE,asp=1)


###################################################
### chunk number 21: 
###################################################
png(file="LogConcDEAD-fig:2d.png")
par(mfrow=c(1,2), pty="s", cex=0.7) #square plots
plot(out,g=g,addp=FALSE,asp=1)
plot(out,g=g,uselog=TRUE,addp=FALSE,asp=1)
dev.off()


###################################################
### chunk number 22: plot:2dmarg eval=FALSE
###################################################
## par(mfrow=c(1,2), pty="s", cex=0.7) #normal proportions 
## plot(out,marg=1,g.marg=g1)
## plot(out,marg=2,g.marg=g2)


###################################################
### chunk number 23: fig:2dmarg
###################################################
par(mfrow=c(1,2), pty="s", cex=0.7) #normal proportions 
plot(out,marg=1,g.marg=g1)
plot(out,marg=2,g.marg=g2)


###################################################
### chunk number 24: plot:rgl eval=FALSE
###################################################
## plot(out,g=g,type="r")


###################################################
### chunk number 25: plot:rgllog eval=FALSE
###################################################
## plot(out,g=g,type="r",uselog=TRUE)


###################################################
### chunk number 26:  eval=FALSE
###################################################
## plot(out,g=g,type="r")
## par3d(windowRect = c(55,66,311+256, 322+256))
## rgl.snapshot(file="rglfig.png")


###################################################
### chunk number 27:  eval=FALSE
###################################################
## plot(out,g=g,type="r",uselog=TRUE)
## par3d(windowRect = c(55,66,311+256, 322+256))
## rgl.snapshot(file="rgllog.png")


###################################################
### chunk number 28: 
###################################################
nsamp <- 1000
mysamp <- rlcd(nsamp,out)


###################################################
### chunk number 29: 
###################################################
apply(mysamp,2,mean)
cov(mysamp)


###################################################
### chunk number 30: 
###################################################
m <- 10
mypoints <- 1.5*matrix(rnorm(m*d),ncol=d)


###################################################
### chunk number 31: 
###################################################
dlcd(mypoints,out)


###################################################
### chunk number 32: 
###################################################
myval <- sort(dlcd(mysamp,out))
alpha <- c(.25,.5,.75)
myval[(1-alpha)*nsamp]



###################################################
### chunk number 33: setn3
###################################################
n <- 500


###################################################
### chunk number 34:  eval=FALSE
###################################################
## install.packages("mvtnorm")
## library("mvtnorm")


###################################################
### chunk number 35: 
###################################################
set.seed(333)
sigma <- matrix(c(1,0.2,0.2,1),nrow=2)
d <- 2
n <- 500
y <- rmvnorm(n,sigma=sigma)
xall <- round(y,digits=1)


###################################################
### chunk number 36: 
###################################################
tmpw <- getweights(xall)
outw <- mlelcd(tmpw$x,w=tmpw$w)
gw <- interplcd(outw, gridlen=200)


###################################################
### chunk number 37: plot:bin eval=FALSE
###################################################
## par(mfrow=c(1,2), pty="s", cex=0.7) #2 square plots 
## plot(outw,g=gw,asp=1,drawlabels=FALSE)
## plot(outw,g=gw,uselog=TRUE,asp=1,drawlabels=FALSE)


###################################################
### chunk number 38: 
###################################################
png(file="LogConcDEAD-fig:bin.png")
par(mfrow=c(1,2), pty="s", cex=0.7) #2 square plots 
plot(outw,g=gw,asp=1,drawlabels=FALSE)
plot(outw,g=gw,uselog=TRUE,asp=1,drawlabels=FALSE)
dev.off()


###################################################
### chunk number 39: setn4
###################################################
n <- 500


###################################################
### chunk number 40: 
###################################################
set.seed(4444)
d <- 3
n <- 500
x <- matrix(rgamma(n*d,shape=2),ncol=d)
out3 <- mlelcd(x)


###################################################
### chunk number 41: 
###################################################
mypoints <- c(0,2,4)
dmarglcd(mypoints, out3, marg=1)


###################################################
### chunk number 42: plot:3deg eval=FALSE
###################################################
## par(mfrow=c(2,2),cex=0.8)
## plot(out3, marg=1)
## plot(out3, marg=2)
## plot(out3, marg=3)
## tmp <- seq(min(out3$x), max(out3$x),len=100)
## plot(tmp, dgamma(tmp,shape=2), type="l", 
## xlab="X", ylab="true marginal density")
## title(main="True density")


###################################################
### chunk number 43: fig:3deg
###################################################
par(mfrow=c(2,2),cex=0.8)
plot(out3, marg=1)
plot(out3, marg=2)
plot(out3, marg=3)
tmp <- seq(min(out3$x), max(out3$x),len=100)
plot(tmp, dgamma(tmp,shape=2), type="l", 
xlab="X", ylab="true marginal density")
title(main="True density")


